; Script Manager Scripts, build number moved to line 3
const
	cn_buildNumber = "20",
	cs_MaxSpan = 20,
	SlowScanMode = 0
		

/*
To use the debugger, Add this line to default.jss and recompile.
Use "jls_debug.jsb"

Add the following lines to the default.jkm file, making hot key changes as needed
alt+control+windows+f9=ToggleDebugJLS
alt+control+windows+f10=DisplayDebugJLS
alt+control+windows+f11=ClearDebugJLS
*/

include "hjconst.jsh"
Include "jscript.jsm"
Include "common.jsm"

; use "etk_Jsl.jsb"
Use "Script Manager.jsb"

	
globals
; globals for the  logic match finder
	string scmSoundPath,
	int lmfTaskID,
	int lmfFindBump,
	int lmfFindMatch,
	string lmfInDenters,
	string lmfOutDenters,
	string lmfTerminaters,
	string lmfStartingLineNumber,
	string lmfEndingKeywords,
	int lmfLevel,
	int lmfSafety,
	int lmfDir,
	int lmfCase,
	int lmfStartingIndent,
	int lmfWatchCaret,
	int scmWatchCaret, ; for next andprevious script,  or find definition
	string DebugCriterionJLS,
	int scmFirstTime,
	int scmEdgeDetected,
	string scmNamesFile,
	string scmCollectedNames,
	int scmSkipComments,
	int scmDecodeComments,
	int scmInComment,
	int scmSpeakIndentation,
	int scmIndentationCount,
	string scmLastScript,
	string scmKeyMap,
	string ScmHotKey,
	string JLFileName

const
	commentOpen = "/*",
	CommentClose = "*/"


Script  ScriptFileName()
ScriptAndAppNames("script manager jaws 2020 scripts, version " + cn_buildNumber)
EndScript




Function AutoStartEvent ()
	
if (scmFirstTime == 0) then
	if (GetJFWVersion () < 2104015) then
		SayString ("these scripts will only work for jaws 2020 and later.  For older versions use scritps version 17")
		Let scmFirstTime = 1
	endif
endif

Let scmSoundPath = GetJAWSSettingsDirectory () + "\\beepit.wav"
; EtkJslAutoStart()
Let SCMDecodeComments = IniReadInteger ("control", "DecodeComments", 1, "Script Manager.ini")
Let scmNamesFile = IniReadString ("Control", "NamesFile", "", "Script Manager.ini")
if (StringLength (scmCollectedNames) < 3) then
	; empty list
	if (StringLength (scmNamesFile) > 3) then
		; file path exists
		Let scmCollectedNames = FileToString (scmNamesFile)
	endif
endif
EndFunction

Function AutoFinishEvent ()
IniWriteString ("Control", "NamesFile", scmNamesfile, "Script Manager.ini")
EndFunction 




Script HotKeyHelp ()
SayMessage (OT_USER_BUFFER, msgHotKeyHelp)
EndScript

Script JumpToDefinition ()
SetBookmark ("5")
PerformScript JumpToDefinition () ; in the fs supplied scripts
EndScript


Script ReturnFromDefinition ()
GoToBookmark ("5")
EndScript

Void Function SayNonHighlightedText (handle hwnd, string Buffer)
var
	string TheClass

let TheClass = GetWindowClass (hwnd)
if (StringContains (GetWindowName (GetRealWindow (GetFocus ())), sc3_L)) then
	if (GetControlID (hwnd) == 6037) then
	;|| GetControlID (hwnd) == 1070) then
		Say(Buffer, ot_buffer)
		return
	endif
endif
if ((StringContains (GetWindowName (GetRealWindow (GetFocus ())), sc4_L)) 
|| (StringContains (GetWindowName (GetRealWindow (GetFocus ())), sc5_L))) then
	if (GetControlID (hwnd) == 6060) then
		Say(Buffer, ot_buffer)
		return
	endif
endif
SayNonHighlightedText(hwnd, Buffer)
EndFunction

Function SayFocusedWindow ()
var
	handle hFocus,
	handle hReal,
	string realName

Let hFocus = getFocus()		
Let hReal = GetRealWindow (hFocus)	
Let realName = getWindowName (hReal)

if (   (realName == sc2_l)
			|| (realName == sc1_l)) then
	if (GetControlID (hFocus) == 6037) then
		SayFormattedMessage (ot_control_name, msg2_L, msg2_S); "Assign to hotkey"
		return
	endif
endif
SayFocusedWindow ()
EndFunction


String Function DocumentTitleGet ()
var
	string s

Let s = GetWindowName (getRealWindow (GetFocus ()))
Let s = StringSegment (s, ":", 2)
return (stringUpper (s))
EndFunction


String Function LineNumberGet ()
var
	string sStatus,
	string s,
	handle grip

; find the handle of the statusBar window
Let grip = GetAppMainWindow (GetFocus ())
Let grip = FindDescendantWindow (grip, 59393)
if (grip) then
	Let sStatus = GetWindowText (grip, 0)
	Let s = StringSegment (sStatus, " ", 5)
	; if the caps lock is on, we are off by one segment
	if (s == "Line:") then
		Let s = StringSegment (sStatus , " ", 6)
	endif
endif

; do a little bit of validation here.
; if this converts to a nonzero number, it must at least be numeric.
if (StringToInt (s) > 0) then
	return (s)
else
	Say ("invalid line number." , OT_STRING)
	SayString ("go to the view menu, and make sure the status bar is checked")
	return ("0")
endif  
EndFunction


Void Function SetBookmark (string bookmark)
var
	string KeyName,
	string val,
	string JBMFileName

; the JBM file is an ini style file with a jbm (jaws book mark) extension.
; there is one for each document.
Let JBMFileName = DocumentTitleGet () + ".jbm"
; the key name is the bookmark name and number.
Let KeyName = "BookMark" + bookmark
; the key value is the actual line number in this file.
let val = LineNumberGet ()  
IniWriteString ("BookMarks", KeyName, val, JBMFileName)

; bookmark 5 is the one automatically used by the go to function feature.
if (bookmark != "5") then
	Say (FormatString ("Bookmark %1 set", bookmark), OT_STRING)
endif
EndFunction


Void Function GoToLine (string line)
{control+g}  ; activates the goTo line dialog
TypeString (line)
{enter}
pause()
Say ("line " + line, OT_STRING)
SayLine()
return
EndFunction


Void Function GoToBookmark (string bookmark)
var
	string KeyName,
	string JBMFileName,
	string LineNumber

; the JBM file is an ini style file with a jbm (jaws book mark) extension.
; there is one for each document.
Let JBMFileName = DocumentTitleGet () + ".jbm"
; the key name is the bookmark name and number.
Let KeyName = "BookMark" + bookmark
Let LineNumber = IniReadString ("BookMarks", KeyName, "$$$", JBMFileName)
if (LineNumber != "$$$") then
	; valid line number retrieved
	GoToLine (LineNumber)
else
	Say ("bookmark not set", OT_STRING)
endif
EndFunction

Script SetBookMark1 ()
SetBookmark("1")
EndScript


Script SetBookMark2 ()
SetBookmark("2")
EndScript


Script SetBookMark3 ()
SetBookmark("3")
EndScript


Script SetBookMark4 ()
SetBookmark("4")
EndScript



Script GoToBookmark1 ()
GoToBookmark ("1")
EndScript


Script GoToBookmark2 ()
GoToBookmark ("2")
EndScript


Script GoToBookmark3 ()
GoToBookmark ("3")
EndScript


Script GoToBookmark4 ()
GoToBookmark ("4")
EndScript


String Function ItemGet ()
var
	string s,
	int safe,
	string delimiters
Let delimiters = " ,-+*/)%!|"
let safe = 0
; if nothing selected, try selecting the current word
if (not (GetCharacterAttributes () & ATTRIB_HIGHLIGHT)) then
	; nothing highlighted, try the current word
	SaveCursor()
	JawsCursor()
	SaveCursor()
	RouteJawsToPC()
	; scan to the right until we find a delimiter
	While (   (StringContains (delimiters, GetCharacter()) == 0)
			&& (safe < 40))
		NextCharacter()
		Let safe = safe+1
	endwhile
	PriorCharacter()
	ShiftLeftMouseClick () ; select the interval between pc and mouse
	RestoreCursor()
	RestoreCursor()
endif
Delay(2)
; now get the selected text to use as a function name
Let s = GetWindowText (GetFocus(), 1)  ; get the highlighted text
PriorCharacter()
return (s)
EndFunction



String Function FindThisItem (string item)
var
	string sLineNumber
Let sLineNumber = LineNumberGet ()
{control+f}  ; activate the find dialog
TypeString (item)
{enter}
Delay(5)
{escape}
Delay(2)
if (sLineNumber == LineNumberGet ()) then
	return ("")
endif
{DownArrow}
{UpArrow}
Delay(2)
return (GetLine()) 
EndFunction




Void Function AccessFunctionDocumentation (int GoThere)
var
	string s

; get the name of the function called under the cursor
Let s = ItemGet ()  ; the thing under the cursor
; do we go to that function, or just access it's documentation
SpeechOff()
if (GoThere) then
	SetBookMark("5")	
	{control+l} ; script manager go to dialog
else  ; just view it's documentation
	{control+i}
endif
Pause()
TypeString (s)
Pause()
SpeechOn()
if (GoThere) then
	{enter}
endif
EndFunction


Function ConstantDefinitionGet (string sType)
var
	int safe1,
	int safe2,	int found,
	string sTemp,
	string sOriginalFile,
	string sOriginalLine,
	string sLine,
	string sItem,
	string sDocTitle,
	string sFileType,
	string sKnownTypes

Let sItem = ItemGet ()
SayString ("searching for " + sItem)
; Save Our current file and line number, so we can get back here
Let sOriginalFile = DocumentTitleGet ()
Let sOriginalLine = LineNumberGet ()

SpeechOff ()
{LeftArrow}
{RightArrow}
{Control+tab}
Delay(3)
Let sDocTitle = DocumentTitleGet ()
Let safe1 = 0
Let SKnownTypes = "JSM" + sType; search only jsm, or both jsh and jsm
while (   (sDocTitle != sOriginalFile)
		&& (safe1 < 10))
	Let safe1 = safe1+1  ; just to be sure we terminate
	Let sFileType = StringRight (sDocTitle, 3)
	if (   (StringContains (sKnownTypes, sFileType)) 
  && (found == 0)) then
		PCCursor()
		{Control+home}  ; top of file
		Delay(2)
		Let sLine = FindThisItem (sItem)	
		if (StringLength (sLine) > StringLength (sItem)) then
			Let found = 1
			Let sLine = "found in file " + sDocTitle + "\r\n" + sLine + "\r\n"
			; if this is a message, get the rest of the message.
			if (sType == "JSM") then 
				; searching only for messages 
				; collect until we see the @@ terminator
				NextLine()
				Let sTemp = GetLine()
				Let Safe2 = 0
				while (   (StringContains (sTemp, "@@") == 0)
					&& (safe2 < 20))
					Let sLine = sLine + sTemp + "\r\n"
					NextLine()
					Delay(1)
					Let sTemp = GetLine()
					Let safe2 = safe2+1
				EndWhile
			endif  ; searching only for messages
			Let sLine = sLine + "\r\npress escape to close this message"
		endif  ; found it in this document
	endif  ; a jsh file	{Control+tab}
	{Control+tab}
	Delay (3)
	Let sDocTitle = DocumentTitleGet ()
EndWhile

; now, we must be back to the original document, go back to the original line.
if (LineNumberGet () != sOriginalLine) then
	{control+g}
	TypeString (sOriginalLine)
	{enter}
endif
SpeechOn()
if (found == 0) then
	SayString ("not found in any open file")
else
	UserBufferDeactivate()
	SayFormattedMessage (OT_USER_BUFFER, sLine, sLine)
endif
EndFunction

Script FindThisFunction ()
AccessFunctionDocumentation (1)
EndScript


Script ReturnFromThisFunction ()
GoToBookMark ("5")
EndScript


Script GoToFunctionDocumentation ()
var
	handle grip,
	string s

AccessFunctionDocumentation (0)
; now speak relevant information, then close the dialog
Let grip = GetFocus()
While ( (grip) && (GetControlID (grip) != 65535))
	Let Grip = GetNextWindow(grip)
endWhile

While ( (grip) 
	&& (   (GetWindowClass (grip) == "Static")
		|| (GetWindowClass (grip) == "Edit")))
	Let s = GetWindowText (grip, READ_EVERYTHING)
	if (StringLength (s) > 1) then
		Say (s, OT_NO_DISABLE)
	ELSE
		Say (msg3_s, OT_NO_DISABLE)  ; none
	ENDIF
	Let Grip = GetNextWindow(grip)
EndWhile
{Escape}
; clear the highlight
{LeftArrow}
EndScript

Script FindConstantDefinition ()
ConstantDefinitionGet ("JSH")
EndScript


Script FindMessageDefinition ()
ConstantDefinitionGet ("JSM")
EndScript

; etk.jsl interface
Script SelectEvent ()
ETKSelectEvent()
EndScript




Script SpeakAnIntegerValue ()
; speak an integer value, and put it in the debug buffer
var
	string str,
	string sOut
if (InputBox ("Integer Value?", " ", str)) then
	Let sOut = "SayDebugIntJLS (\"" + str + "\", " + str + ") ;@@@test"
	TypeString (sOut)
	{enter}
	SayString ("ok")
else
	SayString ("canceled")
endif
EndScript



Script SpeakAStringValue ()
; speak a string variable, and put it in the debug buffer
var
	string str,
	string sOut
if (InputBox ("String Value?", " ", str)) then
	Let sOut = "SayDebugStringJLS (\"" + str + "\", " + str + ") ;@@@test"
	TypeString (sOut)
	{enter}
	SayString ("ok")
else
	SayString ("canceled")
endif
EndScript



Script PostAnIntegerValue ()
; put this in a message box
var
	string str,
	string sOut
if (InputBox ("Integer Value?", " ", str)) then
	Let sOut = "MessageBox (\"" + str + " = \" + IntToString (" + str + "))"
	TypeString (sOut)
	{enter}
	SayString ("ok")
else
	SayString ("canceled")
endif
EndScript

Script PostAStringValue ()
; put this in a message box
var
	string str,
	string sOut
if (InputBox ("String Value?", " ", str)) then
	Let sOut = "MessageBox (\"" + str + " = \" + " + str + ")"
	TypeString (sOut)
	{enter}
	SayString ("ok")
else
	SayString ("canceled")
endif
EndScript


Script SpeakALiteralString ()
var
	string str,
	string sOut
if (InputBox ("Literal String?", " ", str)) then
	Let sOut = "SayDebugJLS (\"" + str + "\") ;@@@test"
	TypeString (sOut)
	{enter}
	SayString ("ok")
else
	SayString ("canceled")
endif
EndScript


int function PreProcessKeyPressedEvent(int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
if scmWatchCaret then
; this is from the last run, not the current one.
;Prevents user from hearing whole line if they press f2, then home or some other keystroke like an arrow key really fast.
	scmWatchCaret = 0
endIf
return PreProcessKeyPressedEvent(nKey, strKeyName, nIsBrailleKey, nIsScriptKey)
endFunction

void function ProcessKeystrokeAndWatchForChange (string keystroke)
; for all the 'jump to' commands.
; f2, shift+f2, and now f12.
TypeKey (keystroke)
sayCurrentScriptKeyLabel ()
var handle focusWindow = getFocus ()
if getWindowSubtypeCode (focusWindow) == WT_MULTILINE_EDIT 
&& GetWindowClass (FocusWindow) == "Scintilla"
	scmWatchCaret = TRUE
endIf
endFunction


Script NextScript ()
ProcessKeystrokeAndWatchForChange ("f2") 
EndScript


Script PriorScript ()
ProcessKeystrokeAndWatchForChange ("shift+f2") 
EndScript




Script NextScriptOld ()
var
	string sName
Saystring ("hello")
Let scmInComment = 0
TypeCurrentScriptKey()
if (GetJFWVersion () > 700000) then
	; jaws 7.0 or later
	Let sName = ScriptNameGet ()
	if (sName != SCMLastScript) then
		SayString (sName)
	else
		Delay (2)
		Let sName = ScriptNameGet ()
		SayString (sName)
	endif
else
	; jaws 6.2 or earlier
	Pause()
	{leftArrow}
Endif
EndScript



Script PriorScriptOld ()
var
	string sName
Let scmInComment = 0
TypeCurrentScriptKey()
if (GetJFWVersion () > 700000) then
	Let sName = ScriptNameGet ()
	if (sName != SCMLastScript) then
		SayString (sName)
	else
		Delay (2)
		Let sName = ScriptNameGet ()
		SayString (sName)
	endif
else
	; jaws 6.2 or earlier
	Pause()
	{leftArrow}
Endif
EndScript

String Function ScriptNameGet ()
; I added this because fs screwed up the f2 key in jaws 7.0
var
	string sName,
	string str,
	int i,
	int l,
	string sLine

Pause() 
Let str = getLine()
; get the word prior to the left paren
Let l = StringContains (str, "(")
if (l > 0) then
	Let i = l-1
	; maybe there is a space between function name and left paren
	if (Substring (str, i, 1) == " ") then
			Let i = i-1
	endif

	; look backward for the second blank, or start of line
	While (i > 0)
		if (Substring (str, i, 1) == " ") then
			return (SubString (str, i+1, (l-i)-1))
		else
			; not blank yet
			Let i = i-1
		EndIf
	EndWhile
	return ("script name not found")
else
	return ("can not find the left parenthesis")
endif
EndFunction

Void Function KeyPressedEvent (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
Let scmHotKey = strKeyName
KeyPressedEvent (nKey, strKeyName, nIsBrailleKey, nIsScriptKey)
endFunction


Script SearchForHotKey ()
var
	string str,
	string ext


; make sure this is a reasonable thing to do.
; get the extension of the currently focused file
Let str = GetWindowName (GetParent (GetFocus ()))
Let ext = StringRight (str, 4)
if (   (ext != ".jss")
		&& (ext != ".jsl")) then
	SayString ("you must be focused in a jss file, or a jsl file")
	return
Endif
if (StringLength (scmKeyMap) == 0) then
	Let scmKeyMap = StringChopright (str, 4) + ".jkm"
	SayString ("defaulting to " + scmKeyMap)
endif

SayString ("press the hotKey to find its script in keymap " + scmKeyMap)
AddHook (HK_SCRIPT, "KeyboardHook")
TrapKeys(1)
Let scmHotKey = ""
ScheduleFunction ("WatchForHotkey", 1)
EndScript


Function WatchForHotKey ()
; scheduled to watch for hotkey when looking for a attached script.
var 
	string str,
	string sPath

Let sPath = GetJAWSSettingsDirectory () + "\\jls_audio\\HighBeep.wav"
PlaySound (sPath)
if (StringLength (scmHotKey) > 0) then
	; key pressed
	if (scmHotKey != "escape") then
		; remove the left and right hand specifiers
		Let scmHotKey = RemoveFromString (scmHotKey, "Left")
		Let scmHotKey = RemoveFromString (scmHotKey, "Right")
		SayString (scmHotKey)
		if (FindScriptFromHotKey () == 0 ) then
			SayString ("hotKey not found")
		endif			
	else
		SayString ("canceled")
	endif
	TrapKeys(0)
	RemoveHook (HK_SCRIPT, "KeyboardHook")
else
	; no key pressed
	ScheduleFunction ("WatchforHotKey", 10)
endif
EndFunction





Void Function KeyboardHook (string ScriptName, string FrameName)
EndFunction




Script FindHotKeyFromScript ()
var
	string sLine,
	string str,
	string sScript,
	string sScript_u,
	string sAllKeys,
	string sKey,
	string sTest,
	string sLayout,
	int i,
	int j

; make sure this is a reasonable thing to do.
; get the extension of the currently focused file
Let str = StringRight (GetWindowName (GetParent (GetFocus ())), 4)
if (   (str != ".jss")
		&& (str != ".jsl")) then
	SayString ("you must be focused in a jss file, or a jsl file")
	return
Endif

if (StringLength (scmKeyMap) == 0) then
	SayString ("no keymap has been specified.")
	return
endif

Let sScript_u = GetWord()
Let sScript = StringLower (sScript_u)
if (   (StringCompare (sScript, "script") == 0)
		|| (StringContains (sScript, "("))
		||  (StringIsBlank (sScript))) then
	SayString ("not positioned on a script name")
	return
endif
Let sLine = StringLower (GetLine())
If (StringLeft (sLine, 6) != "script") then
	SayString ("this is not a script")
	return
endif

; ok,  reasonable,  lets go
; scan all the keys in the common keys section, then try the specific section
Let sLayout = "common keys"
Let j = 2
While (j > 0)
	Let sAllKeys = IniReadSectionKeys (sLayout, scmKeyMap)
	Let i = 1
	Let sKey = StringSegment (sAllKeys, "|", i)
	While (StringLength (sKey) > 0)
		Let sTest = StringLower (IniReadString (sLayout, sKey, "$", scmKeyMap))
		if (sTest == sScript) then
			SayString (sKey)
			return
		endif
		Let i = i+1
		Let sKey = StringSegment (sAllKeys, "|", i)
	EndWhile
	Let j = j-1
	Let sLayout = GetKeyboardLayout ()
EndWhile

; else it was not found
SayString (FormatString ("no hotKey found for %1 in %2", sScript_u, scmKeyMap))
EndScript

Int Function FindScriptFromHotKey ()
; use the global hot key that was collected
var
	string sPath,
	string str

; get the jkm file for the app whose scripts we are editing
Let sPath = GetJAWSSettingsDirectory () + "\\" + scmKeyMap
; try to find the script name
Let str = IniReadString ("Common Keys", scmHotKey, "$", sPath)
if (str == "$") then
	; not found in common keys
	Let str = IniReadString (GetKeyboardLayout(), scmHotKey, "$", sPath)
endif
if (str != "$") then
	; script found
	{control+l}
	Pause()
	TypeString (str)
	{enter}
	return (1)
else
	Return(0)
endif
EndFunction



String Function GetKeyboardLayout ()
var
	string sPath,
	int i,
	int j,
	string str


; this changed radically in jaws 6.0.
if (GetJFWVersion () >= 600000) then
	; jaws 6.0 or later, try user_specific settings first
	Let sPath = GetJAWSSettingsDirectory () + "\\default.jcf"
	if (FileExists (sPath) == 0) then
		; default back to the shared settings version
		Let sPath = GetSharedSettingsDirectory () + "\\default.jcf"
	endif  ; no user-specific file 
	Let str = INIReadString ("options", "KeyboardType", "Desktop", sPath) + " Keys"
	return (str)
endif

; otherwise, it is jaws 5.1 or earlier
Let sPath = GetJAWSSettingsDirectory ()
; we want the folder two levels above this, so we have to trim off the last two levels.
; scan backward looking for the second backslash
Let i = StringLength (sPath)
let j = 0
While (i > 0)
	if (SubString (sPath, i, 1) == "\\") then
		Let j = j+1
		if (j == 2) then
			; found the second backslash
			Let sPath = SubString (sPath, 1, i)
			Let i = 0  ; escape loop
		endif  ; second backslash 
	endif ; found a backslash
	Let i = i-1
	if (   (i <= 0) 
		&& (j != 2)) then
		; reached the end unexpectedly
		return ("Desktop Keys")
	endif
Endwhile
Let sPath = sPath + "user.ini"
Let str = INIReadString ("options", "keyboardType", "Desktop", sPath) + " Keys"
return (str)
EndFunction




Int Function SEqual (string str1, string str2)
if (StringLength(str1) == StringLength(str2)) then
	if (str1 == str2) then
		return(1)
	endif
endif
return(0)
EndFunction

String Function RemoveFromString (string str, string sRemove)
; remove all occurrences of text from a string
; provide:  the string to be edited
;     The text to be removed
;  returns: The revised string
var
	int i,
	int LR,
	string sOut

Let sOut = ""
Let lr = StringLength (sRemove)
; loop while str still contains the offending string
Let i = StringContains (str, sRemove)
while  (i != 0)
	Let sOut = sOut + SubString (str, 1, i-1)
	Let str = stringChopLeft (str, (i+lr)-1)
	Let i = StringContains (str, sRemove)
EndWhile
Let sOut = sOut + str   ; include  what remains
return (sOut)
EndFunction


Script SpecifyKeyMap ()
var
	string str,
	string sPath
Let str = scmKeyMap
if (InputBox ("Keymap File Name, including extension", " ", str)) then
	; make sure the file exists
	Let sPath = GetJAWSSettingsDirectory () + "\\" + str
	if (FileExists (sPath)) then
		let scmKeyMap = str
	else
		SayString (FormatString ("file %1 does not exist.  Input Canceled.", str))
		return
	endif
else
	SayString ("input canceled")
endif
EndScript


Script SetKeyMap ()
; automatic setting to the current document.
var
	string str

; get the jkm file for the app whose scripts we are editing
Let str = GetWindowName (GetParent (GetFocus ()))
if (stringRight (str, 4) != ".jss") then
	SayString ("not focused in a JSS file.  value not set.")
	return
endif
Let scmKeyMap = stringChopRight (str, 4) + ".jkm"
SayString ("key map set to " + scmKeyMap)
EndScript










String Function GetKeywordJS ()
var
	int i,
	int l,
	string str,
	string sLine,
	string sDelimiters

Let sDelimiters = " ;(" 
Let sLine = StringLower (StringTrimLeadingBlanks (GetLine ()))
Let sLine = StringTrimTrailingBlanks (sLine)
Let l = stringLength (sLine)
Let i = 1
; strip off any comments, or the logic clause for  the if or while 
; all we want is the starting key word
While (i <= l)
	if (StringContains (sDelimiters, SubString (sLine, i, 1))) then
		Let str = SubString (sLine, 1, i-1)
		Let i = l+2
	else
		Let i = i+1
	endif
EndWhile

if (i == (l+1)) then
	; no delimiter found
	Let str = sLine
else
	Let str = StringTrimLeadingBlanks (str)
	Let str = StringTrimTrailingBlanks (str)
endif
if (StringContains ("if|endif|else|elif|while|endwhile", str)) then
	return (str)
endif
return ("")
EndFunction


Int Function ListContainsJS (string sList, string sItem)
if (StringSegmentIndex (sList, "|", sItem, 1)) then
	return (1)
endif
return(0)
EndFunction

Void Function FindMatchJS (string startingKeyword, int dir)
var
	int Level,
	int safety,
	string currentKey,
	int case,
	int startingIndent,
	int endingIndent

; load the globals,  and sed caret moved event to the task
SpeechOff()
Let lmfStartingLineNumber = LineNumberGet()
Let lmfCase = 0
Let lmfSafety = cs_MaxSpan-1
Let lmfLevel = 1
Let lmfStartingIndent = CountIndentationJS ()
Let SCMEdgeDetected = 0
Let LMFFindMatch = 1
if (SlowScanMode) then
	Let lmfTaskID = ScheduleFunction ("WatchdogCME", 10)
endif
if (dir > 0) then
	NextLine()
	if (SlowScanMode == 0) then
		NextLine()
	endif
else
	PriorLine()
	if (SlowScanMode == 0) then
		priorLine()
	endif
endif

if (SlowScanMode) then
	; function SearchForMatchCME  in the caret moved event takes it from here
else
	; the fast scan method
	Let safety = 1000
	While (SearchForMatchCME())
		Let safety = safety-1
		if (safety <= 0) then
			SayString ("SearchForMatchCME never returned 0")
			return
		endif
	endWhile
endif
EndFunction


Function SayThis (string str)
SpeechOn()
SayString (str)
EndFunction


Int Function SearchForMatchCME ()
; part of caret moved event
var
	int i,
	string s,
	string currentKey,
	int endingIndent

if (lmfFindMatch) then
	; tell the watchdog we are running
	if (SlowScanMode) then
		if (lmfTaskID) then
			UnScheduleFunction (lmfTaskId)
		endif
	endif ; slow scan mode
	if (lmfSafety <= 0) then
		; exhausted
		Let LMFFindMatch = 0
		SayThis (FormatString ("not found in %1 lines", intToString (cs_MaxSpan)))
		RestoreToLine (lmfStartingLineNumber)
		return(0)
	endif
	if (SlowScanMode) then
		if (((lmfSafety+5) % 10) == 0) then
			PlaySound (scmSoundPath)
		endif
	endif ; slow scan mode

	Let currentKey = GetKeywordJS ()
	; is this an opener, or a closer
	if (ListContainsJS (msgOpeners, currentKey)) then
		Let lmfLevel = lmfLevel + lmfDir
	elif (ListContainsJS (msgClosers, currentKey)) then
		Let lmfLevel = lmfLevel - lmfDir
	elif (ListContainsJS (msgIntermediate, currentKey)) then
		Let lmfCase = 1
	elif (ListContainsJS (msgTerminators, currentKey)) then
		SayThis ("end of function encountered")
		RestoreToLine  (lmfStartingLineNumber)
		Let lmfFindMatch = 0
		return(0)
	endif
	
	; are we done?
	if ((lmfLevel-lmfCase) == 0) then
		; done
		; for fast scan mode,  we need to back up one line
		if (SlowScanMode == 0) then
			if (lmfDir > 0) then
				; back up one
				PriorLine()
			else
				NextLine()
			endif
			pause()
		endif
		SpeechOn()
		sayLine()
		BrailleRefresh (0)
		; validate the ending key word
		Let i = StringSegmentIndex (lmfEndingKeywords , "%", currentKey, 1)
		if (i == 0) then
			SayString (FormatString ("unexpected ending keyword %1", currentKey))
		endif
		Let endingIndent = CountIndentationJS ()
		if (lmfStartingIndent != endingIndent) then
			SayString (FormatString ("warning: starting indentation was %1, but the ending indentation was %2.", IntToString (lmfStartingIndent), intToString(endingIndent)))
		endif
		Let lmfFindMatch = 0
		return(0)
	endif
	Let lmfCase = 0
	Let lmfSafety = lmfSafety-1

	; retrigger the watchdog, in case we  hit end of file
	if (SlowScanMode) then
		Let lmfTaskId = ScheduleFunction ("WatchdogCME", 10) 
	endif
	; next line?
	if (SlowScanMode) then
		if (lmfDir > 0) then
			ScheduleFunction ("NextLine", 0)
		else
			ScheduleFunction ("PriorLine", 0)
		endif
	else
		; fast scan mode
		if (lmfDir > 0) then
			NextLine()
		else
			PriorLine()
		endif
	endif
	return (1) ; more to do
else  ; lmfFindMatch is not set
	return (0)
endif
EndFunction


Function WatchdogCME ()
; should time out,  and restore speech, if the caret stopss moving
; gets restarted all the time, so should never run unless things stop
RestoreToLine (lmfStartingLineNumber)
pause()
BrailleRefresh(0)
SpeechOn()
SayString ("not found")
Let lmfFindMatch = 0
EndFunction


Int Function CountIndentationJS ()
var
	string sLine,
	int i,
	int l

Let sLine = GetLine()
Let l = stringLength (sLine)
; CopyToClipboard ("|" + sLine + "|")
Let i = 1
while  (i < l)
	if (SubString (sLine, i, 1) != "\011") then
		return (i-1)
	endif
	Let i = i+1
Endwhile
return(0)
EndFunction



Script MatchUp ()
var
	string sKeyWord,
	int dir,
	int i,
	string StartingLineNumber,
	string starts,
	string ends

Let starts =
"endif|else|elif|endwhile|endfor|endforeach"

Let ends =
"else%elif%if|elif%if|elif%if|while|for|foreach"

; save the starting line to the file, in case we get lost
Let lmfStartingLineNumber = SaveStartingLine()
if (lmfStartingLineNumber == "0") then
	return
endif

Let sKeyword = GetKeywordJS()
if (StringLength (sKeyword) == 0) then
	SayString ("not positioned on a starting keyword")
	return
endif
Let i = StringSegmentIndex (starts, "|", sKeyword, 1)
if (i == 0) then
	SayString (FormatString ("%1 is not a valid upward starting keyword", sKeyword))
	return
endif
Let lmfEndingKeywords = StringSegment (ends, "|", i)
Let lmfDir = -1 ; default to, up
if (StringSegmentIndex ("if|while", "|", sKeyWord, 1)) then
	Let lmfDir = 1 ; go down to find these
elif (StringSegmentIndex ("endif|endwhile", "|", sKeyWord, 1)) then
	Let lmfDir = -1
endif
FindMatchJS (sKeyWord, lmfDir)
EndScript


Script MatchDown ()
var
	string sKeyWord,
	int dir,
	int i,
	string StartingLine,
	string starts,
	string ends

Let starts = 
"if|else|elif|while|for|foreach"
let ends = 
"else%elif%endif|endif|elif%else%endif|endwhile|endfor|endforeach"

; save the starting line to the file, in case we get lost
Let startingLine = SaveStartingLine()
if (StartingLine == "0") then
	return
endif

Let sKeyword = GetKeywordJS()
if (StringLength (sKeyword) == 0) then
	SayString ("not positioned on a starting keyword")
	return
endif
Let i = StringSegmentIndex (starts, "|", sKeyword, 1)
if (i == 0) then
	SayString (FormatString ("%1 is not a valid downward starting keyword", sKeyword))
	return
endif
Let lmfEndingKeywords = StringSegment (ends, "|", i)

Let lmfDir = 1
if (StringSegmentIndex ("if|while", "|", sKeyWord, 1)) then
	Let lmfDir = 1
elif (StringSegmentIndex ("endif|endwhile", "|", sKeyWord, 1)) then
	Let lmfDir = -1
endif

FindMatchJS (sKeyWord, lmfDir)
EndScript



Function RestoreToLine (string sLineNumber)
speechOff()
{control+g}
	TypeString (sLineNumber)
	EnterKey()
	delay(3)
	SpeechOn()
	SayLine()
EndFunction

Script ReturnToStartingLine ()
var
	string startingLine,
	string scriptName

Let scriptName = ScriptFileNameGet()
Let startingLine = iniReadString ("LineNumbers", scriptName, "0", "Script Manager.ini")
if (startingLine != "0") then
	SayString ("returning to line " + StartingLine)
	RestoreToLine (startingLine)
else
	SayString ("no starting line found for file " + scriptName)
endif
EndScript


Script SpeakCurrentLineNumber ()
SayString ("line " + LineNumberGet())


EndScript


Script SpeakIndentationLevel ()
if (IsSameScript ()) then
	; toggle automatic speaking of indentation
	if (scmSpeakIndentation) then
		Let scmSpeakIndentation = 0
		SayUsingVoice (VCTX_MESSAGE, "indentation speak disabled", OT_STRING)
	else
		Let scmSpeakIndentation = 1
		SayUsingVoice (VCTX_MESSAGE, "indentation speak enabled", OT_STRING)
	endif 
else
	; not a double click
	SayInteger (CountIndentationJS())
endif
EndScript

Script test ()
var
	string s,
	int i

Let s = DocumentTitleGet()
SayDebugStringJLS ("s", s) ;@@@test








; SayInteger (i)
; SayString (str)


EndScript



Script NewLineSameLevel ()
var
	int count
; make a new line at the current indentation
Let count = CountIndentationJS()
SayString ("level " + IntToString (count))
{end}
EnterKey()
EndScript



Script NewLinePrevLevel ()
; make a new line at the next outer indentation
var
	int count,
	int shift

Let count = CountIndentationJS()
if (count > 0) then
	Let shift = 1
	Let count = count-1
endif

SayString ("level " + IntToString (count))
{end}
EnterKey()
if (shift) then
	{backspace}
endif
EndScript


Script NewLineNextLevel ()
; make a new line at the next deeper indentation
var
	int count

Let count = CountIndentationJS()+1
SayString ("level " + IntToString (count))
{end}
EnterKey()
{tab}
EndScript


Function SayLine()
; modified to speak comments in the message voice
var
	string sLine,
	string sFirst,
	string sLast,
	int i,
	int iCount,
	string sCount

/*
we are saying stuff in the comment voice
how do you like it
*/

; keep track of indentation
Let iCount = CountIndentationJS() 
if (iCount != scmIndentationCount) then
	Let scmIndentationCount = iCount
	if (scmSpeakIndentation) then
		Let sCount = IntToString (iCount)
		SayUsingVoice (VCTX_MESSAGE, sCount, OT_STRING)
	endif
endif

if (scmDecodeComments == 0) then
	SayLine()
	return
endif
; else, we can speak comments in a different voice
if (scmInComment) then
	; in a comment block
	SayUsingVoice (VCTX_MESSAGE, getLine(), OT_STRING)
	return
endif

; not in a comment block	
Let sLast = ""
Let sLine = StringTrimLeadingBlanks (GetLine())
Let i = StringContains (sLine, ";")
if (   (i > 0) 
			|| (scmInComment)) then
	Let sFirst = StringLeft (sLine, i-1)
	Let sLast = StringChopLeft (sLine, i)
endif
if (StringLength (sLast) > 0) then
	SayString (sFirst)
	if (scmSkipComments == 0) then
		SayUsingVoice (VCTX_MESSAGE, sLast, OT_STRING)
	endif
else ; not that way
	SayLine()
endif
EndFunction

Script SayPriorLine()
var
	string sLine

if (scmSkipComments) then
	PerformScript SkipUpPastComments()
	return
endif

Let sLine = GetLine()
if (StringContains (sLine, commentOpen)) then
	Let scmInComment = 0
elif (StringContains (sLine, commentClose)) then
	Let scmInComment = 1
endif
PerformScript SayPriorLine()
EndScript

Script SayNextLine()
var
	string sLine

if (scmSkipComments) then
	PerformScript SkipDownPastComments()
	return
endif

Let sLine = GetLine()
if (StringContains (sLine, CommentOpen)) then
	Let scmInComment = 1
elif (StringContains (sLine, CommentClose)) then
	Let scmInComment = 0
endif
PerformScript SayNextLine()
EndScript


Script NotInCommentAnymore ()
if (IsSameScript ()) then
	if (scmDecodeComments) then
		Let scmDecodeComments = 0
		SayString ("comments spoken in the normal voice")
	else
		Let scmDecodeComments = 1
		SayString ("comments spoken in the message voice")
		Let scmInComment = 0
	endif
	IniWriteInteger ("control", "DecodeComments", scmDecodeComments, "Script Manager.ini")
	return
endif
SayString ("If you say so,  then weere not in a comment anymore")
Let scmInComment = 0
EndScript


Script CollectThisName ()
var
	int i,
	string sWord

Let sWord = GetSelectedText (0, 0)
if (StringLength (sWord) <= 2) then
	Let sWord = GetWord()
endif

if (StringIsBlank (sWord) == 0) then
	; got something
	Let sWord = StringTrimTrailingBlanks (sWord)
	if (StringLength (scmcollectedNames) == 0) then
		Let scmCollectedNames = sWord
	else
		; other names exist
		Let scmCollectedNames = scmCollectedNames + "|" + sWord
	endif
	SayString ("Captured " + sWord)
else
	; nothing found
	sayString ("not on a word")
endif
EndScript


Script CollectThisText ()
var
	string str

if (InputBox ("Type text to be added to the reference list", " ", str)) then
	if (StringLength (scmCollectedNames) > 0) then
		Let str = "|" + str
	endif
	Let  scmCollectedNames = scmCollectedNames + str
	SayString ("added")
else
	SayString ("canceled")
endif
EndScript


Script RemoveCollectedItem ()
var
	int i,
	string str,
	string sOut,
	int iSelected,
	int segCount

if (IsSameScript ()) then
	; clear the list?
	Let i = ExMessageBox ("Clear the collected names?", "Confirm", MB_YESNOCANCEL|MB_DEFBUTTON2)
	if (i == 6) then
		Let scmCollectedNames = ""
		SayString ("names discarded")
	else
		SayString ("canceled")
	endif
	return
else
	; not double click
	delay(3)
	if (IsKeyWaiting ()) then
		return
	endif
endif ; not double click


Let ISelected = DlgSelectItemInList (scmCollectedNames, "Item to remove", 1, 1)
if (iSelected > 0) then
	Let str = StringSegment (scmCollectedNames, "|", iSelected)
	SayString ("removing " + str)
	Let segCount = StringSegmentCount (scmCollectedNames, "|")
	Let i = 1
	while (i <= segCount)
		if (i != iSelected) then
			Let sOut = sOut + "|" + StringSegment (scmCollectedNames, "|", i)
		endif
		Let i = i+1
	endWhile
	Let scmCollectedNames = StringChopLeft (sOut, 1)
else
	SayString ("canceled")
endif
EndScript


Script ChooseCollectedNames ()
var
	int i,
	string sName

if (stringLength (scmCollectedNames)> 0) then
	Let i = DlgSelectItemInList (scmCollectedNames, "Collected Names", 1, 1)
	if (i > 0) then
		Let sName = StringSegment (scmCollectedNames, "|", i)	
		TypeString (sName)
	else
		SayString ("canceled")
	endif
else
	; no names
	SayString ("there are no collected names.")
endif
EndScript


Script SaveNamesToFild ()
var
	string sTitle,
	string str,
	string sPath,
	string sFileList,
	int i,
	string sFileName,
	string sSelection,
	int iDelete

if (StringIsBlank (scmCollectedNames)) then
	let iDelete = 1
endif

Let sFileList = FileNameList ("*.sil", "|")
if (StringLength (sFileList) < 3) then
	Let sFileList = msgNoFilesFound
else
	; we got files
	; remove the leading delimiter if present.  Jaws 10 adds it.
	; jaws 11 doesn't, and we don't want these.
	Let sFileList = TrimOuterVerticals (sFileList)
endif
if (iDelete) then
	SayString ("choose a file to delete")
	Let sTitle = "Delete File"
else
	Let sTitle = "Save  To File"
	Let sFileList = sFileList + "|" + msgCreateNewFile
endif
Let i = DlgSelectItemInList (sFileList, sTitle, 1, 1)  
if (i > 0) then
	Let sSelection = StringSegment (sFileList, "|", i)
	if (sSelection == msgCreateNewFile) then
		; get a new file name
		Let str = GetWindowName (GetParent (GetFocus ()))
		Let sFileName = StringChopRight (str, 4) + ".sil"
		InputBox ("FileName?", " ", sFileName)
		; add the .sil extension if needed
		if (StringRight (sFileName, 4) != ".sil") then
			Let sFileName = sFileName + ".sil"
		endif
	else
		; save to selected
		Let sFileName = sSelection + ".sil"
	endif
	if (StringIsBlank (sFileName) == 0) then
		; file selected
		Let sPath = GetJAWSSettingsDirectory () + "\\" + sFileName
		if (iDelete) then
			DeleteFile (sPath)
			SayString ( sFileName + " deleted")
			Let SCMNamesFile = ""
			IniRemoveKey ("Control", "NamesFile", "Script Manager.ini")
		else
			; saving
			StringToFile (scmCollectedNames, sPath)
			SayString ("saved to " + 		sFileName)
			IniWriteString ("Control", "NamesFile", sPath, "Script Manager.ini")
			Let scmNamesFile = sPath
		endif
		return
	endif ; file selected
endif ;; i > 0
SayString ("canceled.")
EndScript



Script LoadNamesFromFile ()
var
	string sPath,
	int i,
	string sFileList,
	string sFileName

Let sFileList = FileNameList ("*.sil", "|")
Let sFileList = TrimOuterVerticals (sFileList)
if (StringIsBlank (sFileList)) then
	SayString ("no .sil files found")
	return
endif

Let i = DlgSelectItemInList (sFileList, "Select File", 1, 1)
if ( i > 0) then
	Let sFileName = StringSegment (sFileList, "|", i) + ".sil"
	Let sPath = GetJAWSSettingsDirectory () + "\\"+ sFileName  
	Let scmNamesFile = sPath
	Let scmCollectedNames = FileToString (sPath)
	SayString ("loaded from " + sFileName)
else
	SayString ("canceled")
endif


EndScript


Int Function StringToFile (string s_text, string s_file)
;Saves string to text file, overwriting if exists
Var
Object Null,
Object o_system,
Object o_file

Let o_system =ObjectCreate ("Scripting.FilesystemObject")
Let o_file =o_system.CreateTextFile(s_file, 1, 0)
o_file.write(s_text)
o_file.close()
Let o_file =Null
Let o_system =Null
EndFunction

Int Function DeleteFile (string s_file)
;Delete file if exist
Var
	Object Null,
	Object o_system

If FileExists(s_file) Then
	Let o_system =ObjectCreate("Scripting.FileSystemObject")
	o_system.DeleteFile(s_file, 1)
	Let o_system =Null
EndIf
Return !FileExists(s_file)
EndFunction


String Function FileToString (string s_file)
;Returns contents of text file
Var
Object Null,
Object o_system,
Object o_file,
String s_return

Let o_system = CreateObject("Scripting.FilesystemObject")
Let o_file =o_system.OpenTextFile(s_file, 1, 0)
Let s_return =o_file.ReadAll()
o_file.close()
Let o_file =Null
Let o_system =Null
Return s_return
EndFunction


Object Function ObjectCreate (string s_object)
;Create object via alternate method if default method fails
Var
	Object o_return

Let o_return =CreateObjectEx(s_object, True)
If !o_return Then
	Let o_return =CreateObjectEx(s_object, False)
EndIf
Return o_return
EndFunction



String Function TrimOuterVerticals (string sFileList)
; For some bversions of jaws the FilesList builtin returns a string that has verticals
;; at the start and end of the string.  We don't want those. 
if (SubString (sFileList, 1, 1) == "|") then
	Let sFileList = stringChopLeft (sFileList, 1)
endif
if (StringRight (sFileList, 1) == "|") then
	Let sFileList = stringChopRight (sFileList, 1)
endif
return (sFileList)
EndFunction

Void Function TopEdgeEvent (handle WindowHandle)
Let scmEdgeDetected = 1
SayString ("beep")
TopEdgeEvent (WindowHandle)
EndFunction

Void Function BottomEdgeEvent (handle WindowHandle)
SayString ("bop")
Let scmEdgeDetected = 2
BottomEdgeEvent (WindowHandle)
EndFunction




Script SkipUpPastComments ()
var
	int iBeeped,
	int preVertical,
	int postVertical,
	string sOldLine,
	string sNewLine,
	string sLine,
	int localComment,
	int safety
SpeechOff()
Let sLine = GetLine()
if (StringContains (sLine, CommentClose)) then
	Let scmInComment = 1
endif
PriorLine() ;@@new
Let localComment = 1
while (scmInComment || localComment)
	; make sure the line number is changing, not at end of file.
	Let preVertical = getCursorRow()
	PriorLine()
	Let safety = safety+1
	if (safety > 20) then
		Let safety = 0
		pause()
		; make sure we are not at the bottom
		Let postVertical = getCursorRow()
		if (preVertical == postVertical) then
			SayThis ("Top of document found")
			Let scmInComment = 0
			return
		endif ; line not changin
	endif ; check every 20 lines for speed
	Let sLine = GetLine()
	if (StringContains (sLine, CommentOpen)) then
		PriorLine()
		Let sLine = GetLine()
		Let scmInComment = 0
	elif (StringContains (sLine, CommentClose)) then
		Let scmInComment = 1
	endif
	if (StringLeft (StringTrimLeadingBlanks (sLine), 1) == ";" )then
		Let localComment = 1
	else
		; no comment marks
		Let localComment = 0
	endif
	if (iBeeped == 0) then
		if (scmInComment || localComment) then
			PlayBeepit ()
			Let iBeeped = 1
		endif
	endIf
EndWhile
NextLine() ; because GetLine always seems to lag behind
pause()
BrailleRefresh(0)
SpeechOn()
SayLine()
EndScript

Script SkipDownPastComments ()
var
	int iBeeped,
	int preVertical,
	int postVertical,
	string sLine,
	int localComment,
	int safety

SpeechOff()
Let sLine = GetLine()
if (StringContains (sLine, CommentOpen)) then
	Let scmInComment = 1
endif

Let localComment = 1
while (scmInComment || localComment)
	; make sure the line number is changing, not at end of file.
	Let preVertical = GetCursorRow()
	NextLine() ;@@new
	NextLine()
	Let safety = safety+1
	if (safety > 20) then
		Let safety = 0
		pause()
		; make sure we are not at the bottom
		Let postVertical = GetCursorRow()
		if (preVertical == postVertical) then
			SayThis ("bottom of document found")
			Let scmInComment = 0
			return
		endif ; line not changing
	endif ; check every 20 lines for speed
	Let sLine = GetLine()
	if (StringContains (sLine, CommentOpen)) then
		Let scmInComment = 1
	elif (StringContains (sLine, CommentClose)) then
		Let scmInComment = 0
		NextLine()
		Let sLine = GetLine()
	endif
	if (StringLeft (StringTrimLeadingBlanks (sLine), 1) == ";" )then
		Let localComment = 1
	else
		; no comment marks
		Let localComment = 0
	endif
	if (iBeeped == 0) then
		if (scmInComment || localComment) then
			PlayBeepit ()
			Let iBeeped = 1
		endif
	endIf
EndWhile
;@@new skipp PriorLine()
pause()
SpeechOn()
BrailleRefresh(0)
SayLine()
EndScript

Script ToggleSkipComments ()
If (scmSkipComments) then
	Let scmSkipComments = 0
	SayString ("Do not skip comments.")
else
	Let scmSkipComments = 1
	sayString ("Skip comments.")
endif
EndScript


Function PlayBeepit ()
var
	string sPath
Let sPath = GetJAWSSettingsDirectory () + "\\beepit.wav"
PlaySound (sPath)
Delay(1)
EndFunction



String Function ScriptFileNameGet ()
; gets the name of the script file with focus
var
	handle hwnd
Let hwnd = getParent (GetParent (GetFocus ()))
return (StringSegment (GetWindowName (hwnd), ":", 2))
EndFunction



Script BumpOutDown ()
BumpPrepare (1)
EndScript


Script BumpOutUp ()
BumpPrepare (-1)
EndScript


Function BumpPrepare (int dir)
SpeechOff()
Let lmfStartingIndent = CountIndentationJS()
; save the starting line to the file, in case we get lost
Let lmfStartingLineNumber = SaveStartingLine()
Let lmfSafety = cs_MaxSpan
Let lmfLevel = 1
Let lmfDir = dir
if (dir == 1) then
	; going down
	lmfInDenters = msgOpeners
	lmfOutDenters = msgClosers
	lmfTerminaters = "endfunction"
else	
	; going up
	lmfInDenters = msgClosers
	lmfOutDenters = msgOpeners
	lmfTerminaters = msgTerminators
endif
	
Let lmfFindBump = 1
Let lmfTaskId = ScheduleFunction ("WatchdogCME", 10)
if (dir == 1) then
	NextLine()
elif (dir == -1) then
	PriorLine()
endif
; FindBumpCME from the caret moved event will take it from here
EndFunction

/*
if (i1) then
	dog and cat
	jim and jenny
	dave and bob
endif
nothing but the best

*/


Function FindBumpCME ()
; runs from the caret moved event
var
	int i,
	string sLine,
	string currentKey,
	string sOut,
	int currentIndent

if (lmfFindBump ) then
	; tell the watchdog we are running
	if (lmfTaskID) then
		UnScheduleFunction (lmfTaskId)
	endif
	if (lmfSafety <= 0) then
		SayThis (FormatString ("not found withint %1 lines", IntToString (cs_MaxSpan)))
		Let lmfFindBump  = 0
		UnScheduleFunction (lmfTaskId)
		RestoreToLine (lmfStartingLineNumber)
		return
	endif

	if (((lmfSafety+5) % 10) == 0) then
		PlaySound (scmSoundPath)
	endif

	Let currentKey = GetKeywordJS ()
	Let i = StringSegmentIndex (lmfTerminaters, "|", currentKey, 1)
	if (i > 0) then
		; not found,  end reached
		SayThis ("not found")
		RestoreToLine (lmfStartingLineNumber)
		BrailleRefresh (0)
		Let lmfFindBump  = 0
		return
	endif

	Let i = StringSegmentIndex (lmfIndenters, "|", currentKey, 1)
	if (i > 0) then
		Let lmfLevel = lmfLevel+1
	else
		Let i = StringSegmentIndex (lmfOutDenters, "|", currentKey, 1)
		if (i > 0) then
			Let lmfLevel = lmfLevel-1
		endif
	endif

	if (lmfLevel == 0) then
		SpeechOn ()
		Let currentIndent = CountIndentationJS() 
		Let sOut = "level " + IntToString (currentIndent)
		SayUsingVoice (VCTX_MESSAGE, sOut, OT_MESSAGE)
		; if not blank, and more than one indentation level changed
		Let sLine = getLine()
		if (StringIsBlank (sLine) == 0) then
			if (lmfStartingIndent > (currentIndent+1)) then
				; indentation error
				Let sOut = "suspected indentation error at line " + LineNumberGet ()
				SayUsingVoice (VCTX_MESSAGE, sOut, OT_STRING)
			else
				SayString (sLine)
			endif
		else ; line is blank
			SayString ("blank")
		endif
		BrailleRefresh (0)
		Let lmfFindBump = 0
		return
	endif  ; reached level 0

	; retrigger the watchdog, in case we  hit end of file
	Let lmfTaskId = ScheduleFunction ("WatchdogCME", 10) 

	; move on to the next line
	if (lmfDir > 0) then
		ScheduleFunction ("NextLine", 0)
	else
		ScheduleFunction ("PriorLine", 0)
	endif
	Let lmfSafety = lmfSafety-1
endif ; running a bump
EndFunction



String Function SaveStartingLine ()
var
	string startingLine,
	string scriptName

; record the current line number, so we can get back here
Let StartingLine = LineNumberGet ()
Let scriptName = scriptFileNameGet()
IniWriteString ("LineNumbers", scriptName, StartingLine, "script manager.ini")
return (startingLine)
EndFunction


Script FindText ()
SaveStartingLine()
TypeCurrentScriptKey ()
EndScript


Script FindNext ()
SaveStartingLine()
TypeCurrentScriptKey ()
EndScript


Script FindPrev ()
SaveStartingLine()
TypeCurrentScriptKey ()
EndScript



Script FindStackFunction ()
var
	string sName,
	int i

Let i = StringContains (DebugCriterionJLS, " ")
if (i > 0) then
	Let sName = StringChopLeft (DebugCriterionJLS, i)
else
	SayString ("space not found")
	return
endif
SayString ("seeking " + sName)
speechOff()

SetBookMark("5")	
{control+l}
pause()
typeString (sName)
Pause()
EnterKey()
pause()
{home}
SpeechOn()
SayLine()
EndScript

void function CaretMovedEvent(int movementUnit, optional int source)
var
	string sName

; logic match finder  control+up and down arrows
if (lmfFindMatch) then
	if (SlowScanMode) then
		SearchForMatchCME()
	endif
elif (lmfFindBump) then
	FindBumpCME()
elif scmWatchCaret then
	scmWatchCaret = 0
	SaveCursor ()
	PcCursor ()
	Let sName = ScriptNameGet ()
	SayString (sName)
	restoreCursor ()
	return
endIf

CaretMovedEvent (movementUnit, source)
endFunction


/*** end of file **/

