; JLS_debug
; Use this file, attach hot keys to it's scripts,  


include "HJConst.jsh"

globals
	int DebugEnabledJLS,
	string DebugRecordJLS,
	string DebugCriterionJLS






Void Function SayDebugStringJLS (string sName, string value)
; post a string variable to the debug buffer
var
	string str
Let str = sName + " = " + value
SayDebugJLS (str)
EndFunction

Void Function SayDebugIntJLS (string sName, int value)
; post an integer variable to the debug buffer
var
	string str
Let str = sName + " = " + IntToString (value)
SayDebugJLS (str)
EndFunction

Function SayDebugJLS (string debugMessage)
; post a text message to the debug buffer
var
	string stack
if (DebugEnabledJLS) then

	; if we are required to have a particular caller, verify that now
	if (StringLength (DebugCriterionJLS) > 0) then
		Let stack = GetScriptCallStack()
		if (StringContains (stack, DebugCriterionJLS) == 0) then
			return ;; not in there
		endif
	endif  ; debug criterion exists
	SayUsingVoice (VCTX_MESSAGE, debugMessage, OT_STRING)
	if (stringLength (debugRecordJLS) == 0) then
		; empty string
		Let debugRecordJLS = debugMessage + "\r\n"
	else
		; existing record
		Let debugRecordJLS = "$" + debugRecordJLS + debugMessage + "\r\n"
		Let debugRecordJLS = stringChopLeft (debugRecordJLS, 1)			
	endif
endif
EndFunction


Script ToggleDebugJLS ()
; turn debugging on or off
if (DebugEnabledJLS) then
	Let debugEnabledJLS = 0
	sayString ("debug disabled")
else
	Let debugEnabledJLS = 1
	sayString ("debug enabled")
	Let DebugCriterionJLS = ""  ; dont limit to jsut certain call chains
endif
EndScript



Script ClearDebugJLS ()
; discard the debug buffer
Let debugRecordJLS = ""
SayString ("debug record discarded")
EndScript


Script DisplayDebugJLS ()
; put the debug buffer into the virtual viewer
if (stringLength (DebugRecordJLS) == 0) then
	SayUsingVoice (VCTX_MESSAGE, "the debug record is empty", OT_STRING)
	return
endif

SayUsingVoice (VCTX_MESSAGE, "virtual viewer", OT_STRING)
UserBufferDeactivate()
UserBufferClear ()
UserBufferAddtext (debugRecordJLS)
UserBufferAddText ("Press escape to close the virtual viewer")
UserBufferActivate()
EndScript




; end of file

